import { Element } from '../../services/xml/Element';
import { ISubtitleContent, ISubtitleContentStyle, ISubtitleContentEvent } from '../../models/ISubtitleContent';
export declare class BaseXMLModel {
    protected _element: Element;
    constructor(element: Element);
    protected _getElement(tagName: string): Element;
}
export declare class SubtitleXMLModel extends BaseXMLModel implements ISubtitleContent {
    readonly id: number;
    readonly title: string;
    readonly locale: string;
    readonly localeString: string;
    readonly wrapStyle: string;
    readonly playResX: string;
    readonly playResY: string;
    readonly styles: ISubtitleContentStyle[];
    readonly events: ISubtitleContentEvent[];
}
export declare class SubtitleStyleXMLModel extends BaseXMLModel implements ISubtitleContentStyle {
    readonly name: string;
    readonly fontName: string;
    readonly fontSize: string;
    readonly primaryColour: string;
    readonly secondaryColour: string;
    readonly outlineColour: string;
    readonly backColour: string;
    readonly bold: string;
    readonly italic: string;
    readonly underline: string;
    readonly strikeout: string;
    readonly scaleX: string;
    readonly scaleY: string;
    readonly spacing: string;
    readonly angle: string;
    readonly borderStyle: string;
    readonly outline: string;
    readonly shadow: string;
    readonly alignment: string;
    readonly marginL: string;
    readonly marginR: string;
    readonly marginV: string;
    readonly encoding: string;
}
export declare class SubtitleEventXMLModel extends BaseXMLModel implements ISubtitleContentEvent {
    readonly start: string;
    readonly end: string;
    readonly style: string;
    readonly name: string;
    readonly marginL: string;
    readonly marginR: string;
    readonly marginV: string;
    readonly effect: string;
    readonly text: string;
}
