var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var BaseXMLModel = /** @class */ (function () {
    function BaseXMLModel(element) {
        this._element = element;
    }
    BaseXMLModel.prototype._getElement = function (tagName) {
        var children = this._element.children;
        for (var i = 0; i < children.length; i++) {
            if (children[i].tagName === tagName) {
                return children[i];
            }
        }
        throw new Error("Element " + tagName + " not found.");
    };
    return BaseXMLModel;
}());
export { BaseXMLModel };
var SubtitleXMLModel = /** @class */ (function (_super) {
    __extends(SubtitleXMLModel, _super);
    function SubtitleXMLModel() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Object.defineProperty(SubtitleXMLModel.prototype, "id", {
        get: function () {
            return parseInt(this._element.getAttribute("id"), 10);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SubtitleXMLModel.prototype, "title", {
        get: function () {
            return this._element.getAttribute("title");
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SubtitleXMLModel.prototype, "locale", {
        get: function () {
            var locale = this._element.getAttribute("lang_code");
            for (var i = 0; i < locale.length; i++) {
                if (locale[i] === "-" || locale[i] === "_") {
                    return locale.substring(0, i) + "-" + locale.substring(i + 1);
                }
                else if (locale[i].toUpperCase() === locale[i]) {
                    return locale.substring(0, i) + "-" + locale.substring(i);
                }
            }
            return locale;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SubtitleXMLModel.prototype, "localeString", {
        get: function () {
            return this._element.getAttribute("lang_string");
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SubtitleXMLModel.prototype, "wrapStyle", {
        get: function () {
            return this._element.getAttribute("wrap_style");
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SubtitleXMLModel.prototype, "playResX", {
        get: function () {
            return this._element.getAttribute("play_res_x");
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SubtitleXMLModel.prototype, "playResY", {
        get: function () {
            return this._element.getAttribute("play_res_y");
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SubtitleXMLModel.prototype, "styles", {
        get: function () {
            return this._getElement("styles")
                .getElementsByTagName("style")
                .map(function (x) { return new SubtitleStyleXMLModel(x); });
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SubtitleXMLModel.prototype, "events", {
        get: function () {
            return this._getElement("events")
                .getElementsByTagName("event")
                .map(function (x) { return new SubtitleEventXMLModel(x); });
        },
        enumerable: true,
        configurable: true
    });
    return SubtitleXMLModel;
}(BaseXMLModel));
export { SubtitleXMLModel };
var SubtitleStyleXMLModel = /** @class */ (function (_super) {
    __extends(SubtitleStyleXMLModel, _super);
    function SubtitleStyleXMLModel() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Object.defineProperty(SubtitleStyleXMLModel.prototype, "name", {
        get: function () {
            return this._element.getAttribute("name");
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SubtitleStyleXMLModel.prototype, "fontName", {
        get: function () {
            return this._element.getAttribute("font_name");
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SubtitleStyleXMLModel.prototype, "fontSize", {
        get: function () {
            return this._element.getAttribute("font_size");
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SubtitleStyleXMLModel.prototype, "primaryColour", {
        get: function () {
            return this._element.getAttribute("primary_colour");
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SubtitleStyleXMLModel.prototype, "secondaryColour", {
        get: function () {
            return this._element.getAttribute("secondary_colour");
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SubtitleStyleXMLModel.prototype, "outlineColour", {
        get: function () {
            return this._element.getAttribute("outline_colour");
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SubtitleStyleXMLModel.prototype, "backColour", {
        get: function () {
            return this._element.getAttribute("back_colour");
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SubtitleStyleXMLModel.prototype, "bold", {
        get: function () {
            return this._element.getAttribute("bold") === '1' ? '-1' : '0';
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SubtitleStyleXMLModel.prototype, "italic", {
        get: function () {
            return this._element.getAttribute("italic") === '1' ? '-1' : '0';
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SubtitleStyleXMLModel.prototype, "underline", {
        get: function () {
            return this._element.getAttribute("underline") === '1' ? '-1' : '0';
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SubtitleStyleXMLModel.prototype, "strikeout", {
        get: function () {
            return this._element.getAttribute("strikeout") === '1' ? '-1' : '0';
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SubtitleStyleXMLModel.prototype, "scaleX", {
        get: function () {
            return this._element.getAttribute("scale_x");
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SubtitleStyleXMLModel.prototype, "scaleY", {
        get: function () {
            return this._element.getAttribute("scale_y");
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SubtitleStyleXMLModel.prototype, "spacing", {
        get: function () {
            return this._element.getAttribute("spacing");
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SubtitleStyleXMLModel.prototype, "angle", {
        get: function () {
            return this._element.getAttribute("angle");
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SubtitleStyleXMLModel.prototype, "borderStyle", {
        get: function () {
            return this._element.getAttribute("border_style");
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SubtitleStyleXMLModel.prototype, "outline", {
        get: function () {
            return this._element.getAttribute("outline");
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SubtitleStyleXMLModel.prototype, "shadow", {
        get: function () {
            return this._element.getAttribute("shadow");
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SubtitleStyleXMLModel.prototype, "alignment", {
        get: function () {
            return this._element.getAttribute("alignment");
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SubtitleStyleXMLModel.prototype, "marginL", {
        get: function () {
            return this._element.getAttribute("margin_l");
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SubtitleStyleXMLModel.prototype, "marginR", {
        get: function () {
            return this._element.getAttribute("margin_r");
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SubtitleStyleXMLModel.prototype, "marginV", {
        get: function () {
            return this._element.getAttribute("margin_v");
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SubtitleStyleXMLModel.prototype, "encoding", {
        get: function () {
            return this._element.getAttribute("encoding");
        },
        enumerable: true,
        configurable: true
    });
    return SubtitleStyleXMLModel;
}(BaseXMLModel));
export { SubtitleStyleXMLModel };
var SubtitleEventXMLModel = /** @class */ (function (_super) {
    __extends(SubtitleEventXMLModel, _super);
    function SubtitleEventXMLModel() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Object.defineProperty(SubtitleEventXMLModel.prototype, "start", {
        get: function () {
            return this._element.getAttribute("start");
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SubtitleEventXMLModel.prototype, "end", {
        get: function () {
            return this._element.getAttribute("end");
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SubtitleEventXMLModel.prototype, "style", {
        get: function () {
            return this._element.getAttribute("style");
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SubtitleEventXMLModel.prototype, "name", {
        get: function () {
            return this._element.getAttribute("name");
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SubtitleEventXMLModel.prototype, "marginL", {
        get: function () {
            return this._element.getAttribute("margin_l");
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SubtitleEventXMLModel.prototype, "marginR", {
        get: function () {
            return this._element.getAttribute("margin_r");
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SubtitleEventXMLModel.prototype, "marginV", {
        get: function () {
            return this._element.getAttribute("margin_v");
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SubtitleEventXMLModel.prototype, "effect", {
        get: function () {
            return this._element.getAttribute("effect");
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SubtitleEventXMLModel.prototype, "text", {
        get: function () {
            return this._element.getAttribute("text");
        },
        enumerable: true,
        configurable: true
    });
    return SubtitleEventXMLModel;
}(BaseXMLModel));
export { SubtitleEventXMLModel };
//# sourceMappingURL=SubtitleContent.js.map